Index: uspace/lib/c/arch/abs32le/include/types.h
===================================================================
--- uspace/lib/c/arch/abs32le/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/abs32le/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -51,4 +51,5 @@
 typedef uint32_t size_t;
 
+typedef int32_t intptr_t;
 typedef uint32_t uintptr_t;
 typedef int32_t intptr_t;
Index: uspace/lib/c/arch/amd64/include/atomic.h
===================================================================
--- uspace/lib/c/arch/amd64/include/atomic.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/amd64/include/atomic.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -45,6 +45,6 @@
 {
 	asm volatile (
-		"lock incq %[count]\n"
-		: [count] "+m" (val->count)
+		"lock incq %0\n"
+		: "+m" (val->count)
 	);
 }
@@ -53,6 +53,6 @@
 {
 	asm volatile (
-		"lock decq %[count]\n"
-		: [count] "+m" (val->count)
+		"lock decq %0\n"
+		: "+m" (val->count)
 	);
 }
@@ -63,7 +63,7 @@
 	
 	asm volatile (
-		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"lock xaddq %1, %0\n"
+		: "+m" (val->count),
+		  "+r" (r)
 	);
 	
@@ -76,7 +76,7 @@
 	
 	asm volatile (
-		"lock xaddq %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"lock xaddq %1, %0\n"
+		: "+m" (val->count),
+		  "+r" (r)
 	);
 	
Index: uspace/lib/c/arch/amd64/include/types.h
===================================================================
--- uspace/lib/c/arch/amd64/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/amd64/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -51,4 +51,5 @@
 typedef uint64_t size_t;
 
+typedef int64_t intptr_t;
 typedef uint64_t uintptr_t;
 typedef int64_t intptr_t;
Index: uspace/lib/c/arch/arm32/include/types.h
===================================================================
--- uspace/lib/c/arch/arm32/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/arm32/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -52,4 +52,5 @@
 typedef uint32_t size_t;
 
+typedef int32_t intptr_t;
 typedef uint32_t uintptr_t;
 typedef int32_t intptr_t;
Index: uspace/lib/c/arch/ia32/include/atomic.h
===================================================================
--- uspace/lib/c/arch/ia32/include/atomic.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia32/include/atomic.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -43,6 +43,6 @@
 {
 	asm volatile (
-		"lock incl %[count]\n"
-		: [count] "+m" (val->count)
+		"lock incl %0\n"
+		: "+m" (val->count)
 	);
 }
@@ -51,6 +51,6 @@
 {
 	asm volatile (
-		"lock decl %[count]\n"
-		: [count] "+m" (val->count)
+		"lock decl %0\n"
+		: "+m" (val->count)
 	);
 }
@@ -61,7 +61,7 @@
 	
 	asm volatile (
-		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"lock xaddl %1, %0\n"
+		: "+m" (val->count),
+		  "+r" (r)
 	);
 	
@@ -74,7 +74,7 @@
 	
 	asm volatile (
-		"lock xaddl %[r], %[count]\n"
-		: [count] "+m" (val->count),
-		  [r] "+r" (r)
+		"lock xaddl %1, %0\n"
+		: "+m" (val->count),
+		  "+r" (r)
 	);
 	
Index: uspace/lib/c/arch/ia32/include/ddi.h
===================================================================
--- uspace/lib/c/arch/ia32/include/ddi.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia32/include/ddi.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -44,7 +44,7 @@
 	
 	asm volatile (
-		"inb %w[port], %b[val]\n"
-		: [val] "=a" (val)
-		: [port] "d" (port)
+		"inb %w1, %b0\n"
+		: "=a" (val)
+		: "d" (port)
 	);
 	
@@ -57,7 +57,7 @@
 	
 	asm volatile (
-		"inw %w[port], %w[val]\n"
-		: [val] "=a" (val)
-		: [port] "d" (port)
+		"inw %w1, %w0\n"
+		: "=a" (val)
+		: "d" (port)
 	);
 	
@@ -70,7 +70,7 @@
 	
 	asm volatile (
-		"inl %w[port], %[val]\n"
-		: [val] "=a" (val)
-		: [port] "d" (port)
+		"inl %w1, %0\n"
+		: "=a" (val)
+		: "d" (port)
 	);
 	
@@ -81,6 +81,6 @@
 {
 	asm volatile (
-		"outb %b[val], %w[port]\n"
-		:: [val] "a" (val), [port] "d" (port)
+		"outb %b0, %w1\n"
+		:: "a" (val), "d" (port)
 	);
 }
@@ -89,6 +89,6 @@
 {
 	asm volatile (
-		"outw %w[val], %w[port]\n"
-		:: [val] "a" (val), [port] "d" (port)
+		"outw %w0, %w1\n"
+		:: "a" (val), "d" (port)
 	);
 }
@@ -97,6 +97,6 @@
 {
 	asm volatile (
-		"outl %[val], %w[port]\n"
-		:: [val] "a" (val), [port] "d" (port)
+		"outl %0, %w1\n"
+		:: "a" (val), "d" (port)
 	);
 }
Index: uspace/lib/c/arch/ia32/include/types.h
===================================================================
--- uspace/lib/c/arch/ia32/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia32/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -51,4 +51,5 @@
 typedef uint32_t size_t;
 
+typedef int32_t intptr_t;
 typedef uint32_t uintptr_t;
 typedef int32_t intptr_t;
Index: uspace/lib/c/arch/ia64/include/types.h
===================================================================
--- uspace/lib/c/arch/ia64/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ia64/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -61,4 +61,5 @@
 typedef uint64_t size_t;
 
+typedef int64_t intptr_t;
 typedef uint64_t uintptr_t;
 typedef int64_t intptr_t;
Index: uspace/lib/c/arch/mips32/include/types.h
===================================================================
--- uspace/lib/c/arch/mips32/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/mips32/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -52,4 +52,5 @@
 typedef uint32_t size_t;
 
+typedef int32_t intptr_t;
 typedef uint32_t uintptr_t;
 typedef int32_t intptr_t;
Index: uspace/lib/c/arch/ppc32/include/types.h
===================================================================
--- uspace/lib/c/arch/ppc32/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/ppc32/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -51,4 +51,5 @@
 typedef uint32_t size_t;
 
+typedef int32_t intptr_t;
 typedef uint32_t uintptr_t;
 typedef int32_t intptr_t;
Index: uspace/lib/c/arch/sparc64/include/types.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/types.h	(revision 107f2e0ef3e7f3b7336408a40acd526c8502baf3)
+++ uspace/lib/c/arch/sparc64/include/types.h	(revision 921b84f17d66df121cdd2a54834689bec11033b1)
@@ -51,4 +51,5 @@
 typedef uint64_t size_t;
 
+typedef int64_t intptr_t;
 typedef uint64_t uintptr_t;
 typedef int64_t intptr_t;