Index: uspace/lib/softint/generic/division.c
===================================================================
--- uspace/lib/softint/generic/division.c	(revision 00acd66d3981789b3f8b04cdd854d29343dd9aa0)
+++ uspace/lib/softint/generic/division.c	(revision 956a22c8acedf4069a38b58d080901e4eed726d8)
@@ -37,8 +37,9 @@
 #include <division.h>
 
-#define ABSVAL(x) ( (x) > 0 ? (x) : -(x))
-#define SGN(x) ( (x) >= 0 ? 1 : 0 )
-				      
-static unsigned int divandmod32(unsigned int a, unsigned int b, unsigned int *remainder)
+#define ABSVAL(x)  ((x) > 0 ? (x) : -(x))
+#define SGN(x)     ((x) >= 0 ? 1 : 0)
+
+static unsigned int divandmod32(unsigned int a, unsigned int b,
+    unsigned int *remainder)
 {
 	unsigned int result;
@@ -53,29 +54,29 @@
 	}
 	
-	if ( a < b) {
+	if (a < b) {
 		*remainder = a;
 		return 0;
 	}
-
-	for ( ; steps > 0; steps--) {
+	
+	for (; steps > 0; steps--) {
 		/* shift one bit to remainder */
-		*remainder = ( (*remainder) << 1) | (( a >> 31) & 0x1);
+		*remainder = ((*remainder) << 1) | (( a >> 31) & 0x1);
 		result <<= 1;
 		
 		if (*remainder >= b) {
-				*remainder -= b;
-				result |= 0x1;
+			*remainder -= b;
+			result |= 0x1;
 		}
 		a <<= 1;
 	}
-
+	
 	return result;
 }
 
-
-static unsigned long long divandmod64(unsigned long long a, unsigned long long b, unsigned long long *remainder)
+static unsigned long long divandmod64(unsigned long long a,
+    unsigned long long b, unsigned long long *remainder)
 {
 	unsigned long long result;
-	int steps = sizeof(unsigned long long) * 8; 
+	int steps = sizeof(unsigned long long) * 8;
 	
 	*remainder = 0;
@@ -87,45 +88,45 @@
 	}
 	
-	if ( a < b) {
+	if (a < b) {
 		*remainder = a;
 		return 0;
 	}
-
-	for ( ; steps > 0; steps--) {
+	
+	for (; steps > 0; steps--) {
 		/* shift one bit to remainder */
-		*remainder = ( (*remainder) << 1) | ((a >> 63) & 0x1);
+		*remainder = ((*remainder) << 1) | ((a >> 63) & 0x1);
 		result <<= 1;
 		
 		if (*remainder >= b) {
-				*remainder -= b;
-				result |= 0x1;
+			*remainder -= b;
+			result |= 0x1;
 		}
 		a <<= 1;
 	}
-
+	
 	return result;
 }
 
 /* 32bit integer division */
-int __divsi3(int a, int b) 
-{
-	unsigned int rem;
-	int result;
-	
-	result = (int)divandmod32(ABSVAL(a), ABSVAL(b), &rem);
-
-	if ( SGN(a) == SGN(b)) return result;
+int __divsi3(int a, int b)
+{
+	unsigned int rem;
+	int result = (int) divandmod32(ABSVAL(a), ABSVAL(b), &rem);
+	
+	if (SGN(a) == SGN(b))
+		return result;
+	
 	return -result;
 }
 
 /* 64bit integer division */
-long long __divdi3(long long a, long long b) 
-{
-	unsigned long long rem;
-	long long result;
-	
-	result = (long long)divandmod64(ABSVAL(a), ABSVAL(b), &rem);
-
-	if ( SGN(a) == SGN(b)) return result;
+long long __divdi3(long long a, long long b)
+{
+	unsigned long long rem;
+	long long result = (long long) divandmod64(ABSVAL(a), ABSVAL(b), &rem);
+	
+	if (SGN(a) == SGN(b))
+		return result;
+	
 	return -result;
 }
@@ -141,5 +142,5 @@
 unsigned long long __udivdi3(unsigned long long a, unsigned long long b)
 {
-	unsigned long long  rem;
+	unsigned long long rem;
 	return divandmod64(a, b, &rem);
 }
@@ -152,13 +153,12 @@
 	
 	/* if divident is negative, remainder must be too */
-	if (!(SGN(a))) {
-		return -((int)rem);
-	}
-	
-	return (int)rem;
+	if (!(SGN(a)))
+		return -((int) rem);
+	
+	return (int) rem;
 }
 
 /* 64bit remainder of the signed division */
-long long __moddi3(long long a,long  long b)
+long long __moddi3(long long a, long long b)
 {
 	unsigned long long rem;
@@ -166,9 +166,8 @@
 	
 	/* if divident is negative, remainder must be too */
-	if (!(SGN(a))) {
-		return -((long long)rem);
-	}
-	
-	return (long long)rem;
+	if (!(SGN(a)))
+		return -((long long) rem);
+	
+	return (long long) rem;
 }
 
@@ -189,5 +188,12 @@
 }
 
-unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b, unsigned long long *c)
+unsigned int __udivmodsi3(unsigned int a, unsigned int b,
+    unsigned int *c)
+{
+	return divandmod32(a, b, c);
+}
+
+unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b,
+    unsigned long long *c)
 {
 	return divandmod64(a, b, c);