Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/console/chardev.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -47,5 +47,5 @@
  *
  */
-void indev_initialize(char *name, indev_t *indev,
+void indev_initialize(const char *name, indev_t *indev,
     indev_operations_t *op)
 {
@@ -130,5 +130,5 @@
  *
  */
-void outdev_initialize(char *name, outdev_t *outdev,
+void outdev_initialize(const char *name, outdev_t *outdev,
     outdev_operations_t *op)
 {
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/console/cmd.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -1033,5 +1033,5 @@
 	/* Execute the test */
 	test_quiet = false;
-	char *ret = test->entry();
+	const char *ret = test->entry();
 	
 	/* Update and read thread accounting */
@@ -1086,5 +1086,5 @@
 		/* Execute the test */
 		test_quiet = true;
-		char * ret = test->entry();
+		const char *ret = test->entry();
 		
 		/* Update and read thread accounting */
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/console/kconsole.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -643,5 +643,5 @@
  *
  */
-void kconsole(char *prompt, char *msg, bool kcon)
+void kconsole(const char *prompt, const char *msg, bool kcon)
 {
 	if (!stdin) {
Index: kernel/generic/src/debug/stacktrace.c
===================================================================
--- kernel/generic/src/debug/stacktrace.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/debug/stacktrace.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -44,7 +44,7 @@
 {
 	int cnt = 0;
-	char *symbol;
+	const char *symbol;
 	uintptr_t offset;
-
+	
 	while (cnt++ < STACK_FRAMES_MAX && ops->frame_pointer_validate(fp)) {
 		if (ops->symbol_resolve &&
@@ -85,5 +85,5 @@
 }
 
-static bool kernel_symbol_resolve(uintptr_t addr, char **sp, uintptr_t *op)
+static bool kernel_symbol_resolve(uintptr_t addr, const char **sp, uintptr_t *op)
 {
 	return (symtab_name_lookup(addr, sp, op) == 0);
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/debug/symtab.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -54,5 +54,5 @@
  *
  */
-int symtab_name_lookup(uintptr_t addr, char **name, uintptr_t *offset)
+int symtab_name_lookup(uintptr_t addr, const char **name, uintptr_t *offset)
 {
 #ifdef CONFIG_SYMTAB
@@ -92,7 +92,7 @@
  *
  */
-char *symtab_fmt_name_lookup(uintptr_t addr)
-{
-	char *name;
+const char *symtab_fmt_name_lookup(uintptr_t addr)
+{
+	const char *name;
 	int rc = symtab_name_lookup(addr, &name, NULL);
 	
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/interrupt/interrupt.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -114,5 +114,5 @@
 
 /** Terminate thread and task if exception came from userspace. */
-void fault_if_from_uspace(istate_t *istate, char *fmt, ...)
+void fault_if_from_uspace(istate_t *istate, const char *fmt, ...)
 {
 	task_t *task = TASK;
@@ -162,5 +162,4 @@
 #if (IVT_ITEMS > 0)
 	unsigned int i;
-	char *symbol;
 
 	spinlock_lock(&exctbl_lock);
@@ -177,5 +176,5 @@
 	
 	for (i = 0; i < IVT_ITEMS; i++) {
-		symbol = symtab_fmt_name_lookup((unative_t) exc_table[i].f);
+		const char *symbol = symtab_fmt_name_lookup((unative_t) exc_table[i].f);
 
 #ifdef __32_BITS__
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/lib/elf.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -48,5 +48,5 @@
 #include <arch.h>
 
-static char *error_codes[] = {
+static const char *error_codes[] = {
 	"no error",
 	"invalid image",
@@ -137,5 +137,5 @@
  * @return NULL terminated description of error.
  */
-char *elf_error(unsigned int rc)
+const char *elf_error(unsigned int rc)
 {
 	ASSERT(rc < sizeof(error_codes) / sizeof(char *));
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/main/kinit.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -183,7 +183,6 @@
 		
 		char namebuf[TASK_NAME_BUFLEN];
-		char *name;
-		
-		name = init.tasks[i].name;
+		
+		const char *name = init.tasks[i].name;
 		if (name[0] == 0)
 			name = "<unknown>";
Index: kernel/generic/src/main/version.c
===================================================================
--- kernel/generic/src/main/version.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/main/version.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -37,20 +37,20 @@
 #include <macros.h>
 
-char *project = "SPARTAN kernel";
-char *copyright = "Copyright (c) 2001-2009 HelenOS project";
-char *release = STRING(RELEASE);
-char *name = STRING(NAME);
-char *arch = STRING(KARCH);
+static const char *project = "SPARTAN kernel";
+static const char *copyright = "Copyright (c) 2001-2010 HelenOS project";
+static const char *release = STRING(RELEASE);
+static const char *name = STRING(NAME);
+static const char *arch = STRING(KARCH);
 
 #ifdef REVISION
-	char *revision = ", revision " STRING(REVISION);
+	static const char *revision = ", revision " STRING(REVISION);
 #else
-	char *revision = "";
+	static const char *revision = "";
 #endif
 
 #ifdef TIMESTAMP
-	char *timestamp = " on " STRING(TIMESTAMP);
+	static const char *timestamp = " on " STRING(TIMESTAMP);
 #else
-	char *timestamp = "";
+	static const char *timestamp = "";
 #endif
 
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/mm/slab.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -130,5 +130,5 @@
 /** Caches for malloc */
 static slab_cache_t *malloc_caches[SLAB_MAX_MALLOC_W - SLAB_MIN_MALLOC_W + 1];
-static char *malloc_names[] =  {
+static const char *malloc_names[] =  {
 	"malloc-16",
 	"malloc-32",
@@ -571,8 +571,7 @@
 
 /** Initialize allocated memory as a slab cache */
-static void
-_slab_cache_create(slab_cache_t *cache, char *name, size_t size, size_t align,
-    int (*constructor)(void *obj, int kmflag), int (*destructor)(void *obj),
-    int flags)
+static void _slab_cache_create(slab_cache_t *cache, const char *name,
+    size_t size, size_t align, int (*constructor)(void *obj, int kmflag),
+    int (*destructor)(void *obj), int flags)
 {
 	int pages;
@@ -631,6 +630,5 @@
 
 /** Create slab cache  */
-slab_cache_t *
-slab_cache_create(char *name, size_t size, size_t align,
+slab_cache_t *slab_cache_create(const char *name, size_t size, size_t align,
     int (*constructor)(void *obj, int kmflag), int (*destructor)(void *obj),
     int flags)
@@ -853,5 +851,5 @@
 		cache = list_get_instance(cur, slab_cache_t, link);
 
-		char *name = cache->name;
+		const char *name = cache->name;
 		uint8_t order = cache->order;
 		size_t size = cache->size;
@@ -896,5 +894,5 @@
 		    NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 	}
-#ifdef CONFIG_DEBUG       
+#ifdef CONFIG_DEBUG
 	_slab_initialized = 1;
 #endif
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/proc/task.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -171,5 +171,5 @@
  *
  */
-task_t *task_create(as_t *as, char *name)
+task_t *task_create(as_t *as, const char *name)
 {
 	ipl_t ipl;
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/proc/thread.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -76,5 +76,5 @@
 
 /** Thread states */
-char *thread_states[] = {
+const char *thread_states[] = {
 	"Invalid",
 	"Running",
@@ -288,5 +288,5 @@
  */
 thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
-    int flags, char *name, bool uncounted)
+    int flags, const char *name, bool uncounted)
 {
 	thread_t *t;
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/synch/spinlock.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -52,5 +52,5 @@
  *
  */
-void spinlock_initialize(spinlock_t *lock, char *name)
+void spinlock_initialize(spinlock_t *lock, const char *name)
 {
 	atomic_set(&lock->val, 0);
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision 7af8c0e6f5392a9da45995cd52a12f36e610fdc1)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision 958de16fdaaa208e93eaa7d3150f9a87db99b693)
@@ -225,5 +225,5 @@
 		int i;
 		unative_t val = 0;
-		char *vtype = NULL;
+		const char *vtype = NULL;
 		
 		